"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_1 = require("react");
var constants_1 = require("./constants");
var util_1 = require("./util");
var react_redux_1 = require("react-redux");
function ModifyChildren(children) {
    if (!children)
        return children;
    if (Array.isArray(children)) {
        if (children.length > 1) {
            return children;
        }
        else {
            return children[0];
        }
    }
    else {
        return children;
    }
}
exports.ModifyChildren = ModifyChildren;
var buildChildren = function (children, name, form, dispatch) { return ModifyChildren(React.Children.map(children, function (element) {
    if (!element.props) {
        return element;
    }
    if (element.props.field) {
        return React.cloneElement(element, {
            value: form[element.props.field] && form[element.props.field].value,
            onChange: function (value) {
                dispatch({
                    type: constants_1.prefix + "/" + name + "/CHANGE_FIELD_" + util_1.toUnderscore(element.props.field),
                    payload: value,
                });
            },
            field: undefined,
        });
    }
    if (element.props.submit) {
        return React.cloneElement(element, {
            onClick: function () {
                if (element.props.onClick)
                    element.props.onClick(form);
            },
        });
    }
    // return element;
    var next = buildChildren(element.props.children, name, form, dispatch);
    return React.cloneElement(element, element.props, next);
})); };
exports.CreateForm = function (_a) {
    var name = _a.name, connect = _a.connect, mapStateToProps = _a.mapStateToProps, mapActionToProps = _a.mapActionToProps;
    connect = connect || react_redux_1.connect;
    var mapState = function (state, ownProps) {
        var origin = mapStateToProps && mapStateToProps(state, ownProps) || {};
        return __assign({}, origin, { form: state.form[name] });
    };
    var element = function (_a) {
        var form = _a.form, children = _a.children, dispatch = _a.dispatch;
        return (React.createElement(react_1.Fragment, null, buildChildren(children, name, form, dispatch)));
    };
    return connect(mapState, mapActionToProps)(element);
};
//# sourceMappingURL=Form.js.map